Index: extensions/PHP_Optimisateur/include/display_config.php
===================================================================
--- extensions/PHP_Optimisateur/include/display_config.php	(revision 9633)
+++ extensions/PHP_Optimisateur/include/display_config.php	(revision 10337)
@@ -5,5 +5,5 @@
 \***************************************/
 
-$PAGE_CONTENT[0] .= '<div class="generic config">
+$PAGE['content'] .= '<div class="generic config">
 		<h2>'.l10n('Configuration').'</h2>
 		<ul>
@@ -56,29 +56,29 @@
 					<tr>
 						<td><b>'.l10n('DIMhd').' :</b></td>
-						<td>'.$CONF['DIMhd'].'px</td>
+						<td>'.$CONF['DIMhd'].' px</td>
 					</tr>
 					<tr>
 						<td><b>'.l10n('DIMnormal').' :</b></td>
-						<td>'.$CONF['DIMnormal'].'px</td>
+						<td>'.$CONF['DIMnormal'].' px</td>
 					</tr>
 					<tr>
 						<td><b>'.l10n('DIMthumbnail').' :</b></td>
-						<td>'.$CONF['DIMthumbnail'].'px</td>
+						<td>'.$CONF['DIMthumbnail'].' px</td>
 					</tr>
 					<tr>
 						<td><b>'.l10n('Qhd').' :</b></td>
-						<td>'.$CONF['Qhd'].'%</td>
+						<td>'.$CONF['Qhd'].' %</td>
 					</tr>
 					<tr>
 						<td><b>'.l10n('Qnormal').' :</b></td>
-						<td>'.$CONF['Qnormal'].'%</td>
+						<td>'.$CONF['Qnormal'].' %</td>
 					</tr>
 					<tr>
 						<td><b>'.l10n('Qthumbnail').' :</b></td>
-						<td>'.$CONF['Qthumbnail'].'%</td>
+						<td>'.$CONF['Qthumbnail'].' %</td>
 					</tr>
 					<tr>
 						<td><b>'.l10n('DPI').' :</b></td>
-						<td>'.$CONF['DPI'].'dpi</td>
+						<td>'.$CONF['DPI'].' dpi</td>
 					</tr>
 				</table>
@@ -128,16 +128,15 @@
 			
 			foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
-				$PAGE_CONTENT[0] .= '<li>
+				$PAGE['content'] .= '<li>
 					<div class="plugin-title">
 						<span class="title">'.$plugin_config['name'].' :</span>
 						
 						<span class="plugin-active">';
-						// Si il est manquant on ne met que la checkbox de suppression, sinon boutons d'activation
 						if ($plugin_config['active']) {
-							$PAGE_CONTENT[0] .= '<b class="new">'.l10n('Active').'</b>';
+							$PAGE['content'] .= '<b class="new">'.l10n('Active').'</b>';
 						} else {
-							$PAGE_CONTENT[0] .= '<b class="miss">'.l10n('Inactive').'</b>';
+							$PAGE['content'] .= '<b class="miss">'.l10n('Inactive').'</b>';
 						}
-						$PAGE_CONTENT[0] .= '</span>
+						$PAGE['content'] .= '</span>
 						
 					</div>';
@@ -147,7 +146,7 @@
 						include('plugins/'.$plugin_id.'/setup.php');
 					}
-				$PAGE_CONTENT[0] .= '</li>';
+				$PAGE['content'] .= '</li>';
 			}
-		$PAGE_CONTENT[0] .= '</ul>
+		$PAGE['content'] .= '</ul>
 	</div>';
 ?>
Index: extensions/PHP_Optimisateur/include/functions.php
===================================================================
--- extensions/PHP_Optimisateur/include/functions.php	(revision 9633)
+++ extensions/PHP_Optimisateur/include/functions.php	(revision 10337)
@@ -1,3 +1,4 @@
 <?php
+
 // Affiche les textes localisés
 function l10n($code) {
@@ -22,5 +23,5 @@
 	while ($file = readdir($dh)) {
 		if ($file !== '.' && $file !== '..' && is_dir('language/'.$file)) {
-			$name = (file_exists('language/'.$file.'/'.$file.'.txt')) ? file_get_contents('language/'.$file.'/'.$file.'.txt') : $file;
+			$name = (file_exists('language/'.$file.'/iso.txt')) ? file_get_contents('language/'.$file.'/iso.txt') : $file;
 			$languages[$file] = $name;
 		}
@@ -66,5 +67,5 @@
 		return preg_replace($search, $replace, $string);
 	} else {
-		return str_replace(array('%','$'), '_', $string);
+		return str_replace(array('%','$',' '), '_', $string);
 	}
 }
@@ -121,5 +122,5 @@
 	$content = array();
 	foreach ($xml as $nom => $elem) { 
-		if (trim($elem) == '') { 
+		if (trim($elem) == '' AND $elem != '') { 
 			$content[$nom] = XMLParse($elem->children()); 
 		} else { 
@@ -165,5 +166,7 @@
 				$array[$key] = true;		
 			} else if ($value === 'false') {
-				$array[$key] = false;		
+				$array[$key] = false;	
+			} else if ($value == null) {
+				// rien à faire ^^
 			} else if (preg_match('#^([0-9]*)$#', $value)) {
 				settype($array[$key], 'int');		
@@ -247,5 +250,5 @@
 // Verifie si une chaine est un nombre décimal (plus strict que is_numeric qui fonctionne avec les hexadecimaux)
 function is_decimal($num) {
-	if(is_numeric($num) === true AND (float)$num == $num) {
+	if((is_numeric($num) === true AND (float)$num == $num) OR $num === '0') {
 		return true;
 	} else {
@@ -257,9 +260,87 @@
 function load_plugin_lang($plugin_id) {
 	global $CONF, $Lang;
-	if (file_exists('plugins/'.$plugin_id.'/lang/'.$CONF['user_lang'].'.php')) {
-		include('plugins/'.$plugin_id.'/lang/'.$CONF['user_lang'].'.php');
-	} else {
-		include('plugins/'.$plugin_id.'/lang/en_UK.php');
-	}
-}
+	if (file_exists('plugins/'.$plugin_id.'/language/'.$CONF['user_lang'].'.php')) {
+		include('plugins/'.$plugin_id.'/language/'.$CONF['user_lang'].'.php');
+	} else {
+		include('plugins/'.$plugin_id.'/language/en_UK.php');
+	}
+}
+
+// fonction nconvert avec gestion du log
+function nconvert($param, $log=true) {
+	global $LOG;
+
+	exec('include\nconvert.exe '. $param .' 2>&1', $out);
+	
+	if ($log) {
+		for ($i=0; $i<=3; $i++)
+			unset($out[$i]);
+		if (count($out)) $LOG[] = array_values($out);
+		//$LOG[] = "\t" . $param;
+	} else {
+		return $out;
+	}
+}
+
+// fonction mkdir avec gestion du log
+function mkdir_log($dir) {
+	global $LOG;
+	mkdir($dir, 0777, true);
+	$LOG[] = 'Dir '.$dir.' created';
+}
+
+// fonction copy avec gestion du log
+function copy_log($src, $dest) {
+	global $LOG;
+	copy($src, $dest);
+	$LOG[] = 'Copy '.$src.' to '.$dest;
+}
+
+// fonction rename avec gestion du log
+function rename_log($path, $new_path, $move=false) {
+	global $LOG;
+	rename($path, $new_path);
+	if ($move)
+		$LOG[] = 'Move '.$path.' to '.$new_path;
+	else
+		$LOG[] = 'Rename '.$path.' into '.$new_path;
+}
+
+// enregistre le log dans un fichier
+function print_log($nb, $s) {
+	global $APPversion, $LOG;
+	
+	$config = file_get_contents('config.xml');
+	
+	$string = 
+		"PHP Optimisateur " . $APPversion . "\r\n".
+		date('r') . "\r\n".
+		$nb . " files in " . $s . " seconds" . "\r\n\r\n".
+		
+		$config . "\r\n\r\n";
+	
+	foreach ($LOG as $event) {
+		if (is_array($event)) {
+			$string .= implode("\r\n", $event) . "\r\n";
+		} else {
+			$string .= $event . "\r\n";
+		}
+	}
+	
+	if (!file_exists('logs')) {
+		mkdir('logs', 0777, true);
+	}
+	
+	$filename = 'log_' . date('Y-m-d_H-i-s') . '.txt';
+	file_put_contents('logs/'.$filename, $string);
+	return $filename;
+}
+
+// case insentive version of in_array
+function in_arrayi($needle, $haystack) {
+	$needle = strtolower($needle);
+	$haystack = array_map('strtolower', $haystack);
+	return in_array($needle, $haystack);
+}
+
 ?>
Index: extensions/PHP_Optimisateur/include/header.php
===================================================================
--- extensions/PHP_Optimisateur/include/header.php	(revision 9633)
+++ extensions/PHP_Optimisateur/include/header.php	(revision 10337)
@@ -35,5 +35,7 @@
 			});
 		});
-	</script>	
+	</script>
+	
+	'.$PAGE['header'].'
 	
 </head>
@@ -48,5 +50,5 @@
 	<div id="languageSwitchLink" title="Change Language">
 		<ul>
-			<li><a href="#"><img src="language/'.$CONF['user_lang'].'/'.$CONF['user_lang'].'.png" alt="'.$CONF['languages'][$CONF['user_lang']].'"/> '.$CONF['languages'][$CONF['user_lang']].'</a></li>
+			<li><a href="#"><img src="language/'.$CONF['user_lang'].'/flag.png" alt="'.$CONF['languages'][$CONF['user_lang']].'"/> '.$CONF['languages'][$CONF['user_lang']].'</a></li>
 		</ul>
 	</div>
@@ -55,5 +57,5 @@
 		<ul>';
 		foreach ($CONF['languages'] as $key => $name) {
-			echo '<li><a class="lang" href="index.php?Lang='.$key.'" title="'.$name.'"><img src="language/'.$key.'/'.$key.'.png" alt="'.$name.'"/> '.$name.'</a></li>';
+			echo '<li><a class="lang" href="index.php?Lang='.$key.'" title="'.$name.'"><img src="language/'.$key.'/flag.png" alt="'.$name.'"/> '.$name.'</a></li>';
 		}
 		echo ' </ul>
Index: extensions/PHP_Optimisateur/include/main.php
===================================================================
--- extensions/PHP_Optimisateur/include/main.php	(revision 9633)
+++ extensions/PHP_Optimisateur/include/main.php	(revision 10337)
@@ -17,5 +17,8 @@
 			$path = $dir.'/'.$file;
 			$new_path = $dir.'/'.delete_special_car($file);
-			rename($path, $new_path);
+			
+			if ($path != $new_path) {
+				rename_log($path, $new_path);
+			}
 			
 			if (is_dir($new_path)) {
@@ -47,5 +50,5 @@
 
 $CONF['convOptions'] = '-ratio -rtype lanczos -rflag decr';
-$CONF['JPGexts'] = array('jpg', 'JPG'); // extensions admises pour le jpg
+$CONF['allowedExt'] = array('jpg', 'jpeg', 'png', 'gif', 'bmp', 'tiff');
 
 
@@ -68,26 +71,37 @@
 // Boucle sur tous les fichiers
 for ($i=0; $i<count($FilesSource); $i++) {
-	// Découpe le nom de fichier : dossier/fichier
-	preg_match('#(.*)/(.*).((?i)[a-z0-9]{3,4})$#', $FilesSortie[$i], $matches);
-	$FileFolder = $matches[1].'/'; // dossier de sortie
-	$FileName = $matches[2]; // nom final
-	$FileExt = $matches[3]; // extension orginale
-		
+	// Découpe le nom de fichier : dossier/fichier/extension
+	preg_match('#^(.*)/(.*)\.([a-z0-9]{2,4})$#', $FilesSource[$i], $matches);
+	$file['folder_src'] = $matches[1].'/'; // dossier d'entrée
+	$file['folder_out'] = str_replace($CONF['DIRsource'], $CONF['DIRsortie'], $file['folder_src']); // dossier de sortie
+	$file['name'] = $matches[2]; // nom final
+	$file['ext'] = $matches[3]; // extension orginale
+			
 	// Crée les sous-dossiers de sortie & 'pwg_high' & 'thumbnail'
-	if (!file_exists($FileFolder.'pwg_high') AND $CONF['DIRhighORNOT']) {
-		mkdir($FileFolder.'pwg_high', 0777, true);
+	if (!file_exists($file['folder_out'].'pwg_high') AND $CONF['DIRhighORNOT']) {
+		mkdir_log($file['folder_out'].'pwg_high');
 	}
-	if (!file_exists($FileFolder.'thumbnail')) {
-		mkdir($FileFolder.'thumbnail', 0777, true);
+	if (!file_exists($file['folder_out'].'thumbnail')) {
+		mkdir_log($file['folder_out'].'thumbnail');
 	}
 	
-	// Informations sur le fichier
-	exec('include\nconvert.exe -info "'.$FilesSource[$i].'"', $FileInfos);
-	for ($m=0; $m<=5; $m++) {
-		unset($FileInfos[$m]);
+	if (!in_arrayi($file['ext'], $CONF['allowedExt'])) {
+		$BlockAll['main'] = true;
+		$LOG[] = 'Not image file : '.$FilesSource[$i];
 	}
-	foreach ($FileInfos as $key) {
-		$a = explode(':', $key);
-		$FileInfos[trim($a[0])] = trim($a[1]);
+	
+	if (!isset($BlockAll)) {
+		// Informations sur le fichier
+		exec('include\nconvert.exe -info "'.$FilesSource[$i].'"', $FileInfos);
+		
+		for ($m=0; $m<=5; $m++) {
+			unset($FileInfos[$m]);
+		}
+		foreach ($FileInfos as $key) {
+			if ($key != '') {
+				$a = explode(':', $key);
+				$FileInfos[trim($a[0])] = trim($a[1]);
+			}
+		}
 	}
 		
@@ -107,25 +121,23 @@
 	
 	// Compresse les fichiers dans le dossier de sortie
-	if (!isset($BlockNormal)) { 
-		exec('include\nconvert.exe -q '.$CONF['Qnormal'].' -out jpeg -o "'.$FileFolder.$FileName.'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMnormal'].' '.$CONF['DIMnormal'].' '.$CONF['copyNormal'].' "'.$FilesSource[$i].'"');
+	if (!isset($BlockNormal) AND !isset($BlockAll)) { 
+		nconvert('-q '.$CONF['Qnormal'].' -out jpeg -o "'.$file['folder_out'].$file['name'].'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMnormal'].' '.$CONF['DIMnormal'].' '.$CONF['copyNormal'].' "'.$FilesSource[$i].'"');
 	}
-	if (!isset($BlockThumbnail)) { 
-		exec('include\nconvert.exe -q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$FileFolder.'thumbnail/'.$CONF['prefixe_mini'].$FileName.'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMthumbnail'].' '.$CONF['DIMthumbnail'].' -rmeta -rexifthumb "'.$FilesSource[$i].'"');
+	if (!isset($BlockThumbnail) AND !isset($BlockAll)) { 
+		nconvert('-q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMthumbnail'].' '.$CONF['DIMthumbnail'].' -rmeta -rexifthumb "'.$FilesSource[$i].'"');
 	}
-	if (!isset($BlockHigh) AND $CONF['DIRhighORNOT']) {
+	if (!isset($BlockHigh) AND $CONF['DIRhighORNOT'] AND !isset($BlockAll)) {
 		if ($CONF['DIMhdORNOT']) {
-			exec('include\nconvert.exe -q '.$CONF['Qhd'].' -out jpeg -o "'.$FileFolder.'pwg_high/'.$FileName.'.jpg" -dpi '.$CONF['DPI'].' '.$CONF['convOptions'].' -resize '.$CONF['DIMhd'].' '.$CONF['DIMhd'].' '.$CONF['copyHD'].' "'.$FilesSource[$i].'"');
-		} else if (!in_array($FileExt, $CONF['JPGexts'])) {
-			exec('include\nconvert.exe -q '.$CONF['Qhd'].' -out jpeg -o "'.$FileFolder.'pwg_high/'.$FileName.'.jpg" "'.$FilesSource[$i].'"');
+			nconvert('-q '.$CONF['Qhd'].' -out jpeg -o "'.$file['folder_out'].'pwg_high/'.$file['name'].'.jpg" -dpi '.$CONF['DPI'].' '.$CONF['convOptions'].' -resize '.$CONF['DIMhd'].' '.$CONF['DIMhd'].' '.$CONF['copyHD'].' "'.$FilesSource[$i].'"');
+		} else if (strtolower($file['ext']) != 'jpg') {
+			nconvert('-q '.$CONF['Qhd'].' -out jpeg -o "'.$file['folder_out'].'pwg_high/'.$file['name'].'.jpg" "'.$FilesSource[$i].'"');
 		} else {
-			copy($FilesSource[$i], $FileFolder.'pwg_high/'.$FileName.'.jpg');
+			copy_log($FilesSource[$i], $file['folder_out'].'pwg_high/'.$file['name'].'.jpg');
 		}
 	}
 	
-	// Réinitialise les bloqueurs
-	unset($FileInfos);
-	unset($BlockNormal);
-	unset($BlockThumbnail);
-	unset($BlockHigh);
+	// Réinitialise les variables
+	unset($file, $FileInfos, $BlockNormal, $BlockThumbnail, $BlockHigh, $BlockAll);
+	$LOG[] = "\r\n";
 }
 
@@ -139,5 +151,5 @@
 		rmdir($dir);
 	} else if ($CONF['indexORNOT']) {
-		copy('include/index.php', $dir.'/index.php');
+		copy_log('include/index.php', $dir.'/index.php');
 	}
 }
Index: extensions/PHP_Optimisateur/include/save_config.php
===================================================================
--- extensions/PHP_Optimisateur/include/save_config.php	(revision 9633)
+++ extensions/PHP_Optimisateur/include/save_config.php	(revision 10337)
@@ -2,37 +2,41 @@
 // Quelques traitements
 $_POST['copyPOS'] = implode('-', $_POST['copyPOS']);
-$_POST['copyCOLOR'] = str_replace('#','', $_POST['copyCOLOR']);
+$_POST['copyCOLOR'] = str_replace('#', null, $_POST['copyCOLOR']);
 $_POST['prefixe_mini'] = delete_special_car($_POST['prefixe_mini']);
-if (!preg_match('#(.*)/$#', $_POST['DIRsource'])) $_POST['DIRsource'] .= '/';
-if (!preg_match('#(.*)/$#', $_POST['DIRsortie'])) $_POST['DIRsortie'] .= '/';
+$_POST['DIRsource'] = rtrim($_POST['DIRsource'], '/') . '/';
+$_POST['DIRsortie'] = rtrim($_POST['DIRsortie'], '/') . '/';
 
 // Vérifications
 if (!is_decimal($_POST['Qhd']) OR $_POST['Qhd'] > 100) {
 	$_POST['Qhd'] = 100;
-	$Errors['ErrorConfig'] = 'notice';
+	$ERRORS['conf'][] = array(l10n('Qhd'), 'must_be_integer_100');
 }
 if (!is_decimal($_POST['Qnormal']) OR $_POST['Qnormal'] > 100) {
 	$_POST['Qnormal'] = 100;
-	$Errors['ErrorConfig'] = 'notice';
+	$ERRORS['conf'][] = array(l10n('Qnormal'), 'must_be_integer_100');
 }
 if (!is_decimal($_POST['Qthumbnail']) OR $_POST['Qthumbnail'] > 100) {
 	$_POST['Qthumbnail'] = 100;
-	$Errors['ErrorConfig'] = 'notice';
+	$ERRORS['conf'][] = array(l10n('Qthumbnail'), 'must_be_integer_100');
 }
 if (!is_decimal($_POST['DIMhd'])) {
 	$_POST['DIMhd'] = 2560;
-	$Errors['ErrorConfig'] = 'notice';
+	$ERRORS['conf'][] = array(l10n('DIMhd'), 'must_be_integer');
 }
 if (!is_decimal($_POST['DIMnormal']) OR $_POST['DIMnormal'] > $_POST['DIMhd']) {
 	$_POST['DIMnormal'] = 800;
-	$Errors['ErrorConfig'] = 'notice';
+	$ERRORS['conf'][] = array(l10n('DIMnormal'), 'must_be_integer');
 }
 if (!is_decimal($_POST['DIMthumbnail']) OR $_POST['DIMthumbnail'] > $_POST['DIMnormal']) {
 	$_POST['DIMthumbnail'] = 120;
-	$Errors['ErrorConfig'] = 'notice';
+	$ERRORS['conf'][] = array(l10n('DIMthumbnail'), 'must_be_integer');
 }
 if (!is_decimal($_POST['DPI'])) {
 	$_POST['DPI'] = 72;
-	$Errors['ErrorConfig'] = 'notice';
+	$ERRORS['conf'][] = array(l10n('DPI'), 'must_be_integer');
+}
+if (!is_decimal($_POST['copySIZE'])) {
+	$_POST['copySIZE'] = 0.05;
+	$ERRORS['conf'][] = array(l10n('copySIZE'), 'must_be_decimal');
 }
 	
@@ -49,4 +53,9 @@
 }
 
+
+// écrase la configuration
+unset($_POST['submit']);
+$CONF = array_merge($CONF, array_settype($_POST));
+
 // Contenu du fichier
 $content = '<?xml version="1.0" encoding="UTF-8"?>'."\r\n".'<config>'."\r\n";
@@ -55,8 +64,9 @@
 file_put_contents('config.xml', $content);
 
-if (isset($Errors['ErrorConfig'])) {
-	header('Location:index.php?page=setup&ErrorConfig='.$Errors['ErrorConfig']);
-} else {
-	header('Location:index.php');
+if (!isset($ERRORS['conf'])) {
+	// header('Location:index.php');
+	$PAGE['header'] .= '<meta http-equiv="refresh" content="3;url=index.php">';
+	$PAGE['end'] .= '<div class="generic finish">'.l10n('Saved').'</div>';
 }
+
 ?>
Index: extensions/PHP_Optimisateur/include/setup.php
===================================================================
--- extensions/PHP_Optimisateur/include/setup.php	(revision 9633)
+++ extensions/PHP_Optimisateur/include/setup.php	(revision 10337)
@@ -27,5 +27,5 @@
 $CONF['copyCOLOR'] = nice_hex_color($CONF['copyCOLOR']);
 
-$PAGE_CONTENT[0] .= '<form action="index.php?page=setup" method="post">
+$PAGE['content'] .= '<form action="index.php?page=setup" method="post">
 	<div class="generic config">
 		<h2>'.l10n('Configuration').'</h2>
@@ -212,5 +212,5 @@
 			
 			foreach ($CONF['Plugins'] as $plugin_id => $plugin_config) {
-				$PAGE_CONTENT[0] .= '<li>
+				$PAGE['content'] .= '<li>
 					<div class="plugin-title">
 						<span class="title">'.$plugin_config['name'].' :</span>
@@ -220,20 +220,20 @@
 						// Cas spéciaux dans le titre (nouveau, manquant)
 						if (isset($NewPlugins[$plugin_id])) {
-							$PAGE_CONTENT[0] .= ' <b class="new">'.l10n('New !').'</b>';
+							$PAGE['content'] .= ' <b class="new">'.l10n('New !').'</b>';
 						} else if (isset($MissingPlugins[$plugin_id])) {
-							$PAGE_CONTENT[0] .= ' <b class="miss">'.l10n('Missing !').'</b>';
+							$PAGE['content'] .= ' <b class="miss">'.l10n('Missing !').'</b>';
 						}
 						
 						// Si il est manquant on ne met que la checkbox de suppression, sinon boutons d'activation
-						$PAGE_CONTENT[0] .= '<span class="plugin-active">';
+						$PAGE['content'] .= '<span class="plugin-active">';
 							if (isset($MissingPlugins[$plugin_id])) {
-								$PAGE_CONTENT[0] .= '<label><input type="checkbox" name="Plugins['.$plugin_id.'][delete]" value="true" checked="checked"/> '.l10n('erase').'</label>';
+								$PAGE['content'] .= '<label><input type="checkbox" name="Plugins['.$plugin_id.'][delete]" value="true" checked="checked"/> '.l10n('erase').'</label>';
 							} else {
-								$PAGE_CONTENT[0] .= '<input type="radio" id="" id="active-'.$plugin_id.'" name="Plugins['.$plugin_id.'][active]" value="true" '.(($plugin_config['active'])?'checked="checked"':'').'/>
+								$PAGE['content'] .= '<input type="radio" id="" id="active-'.$plugin_id.'" name="Plugins['.$plugin_id.'][active]" value="true" '.(($plugin_config['active'])?'checked="checked"':'').'/>
 								<label for="active-'.$plugin_id.'">'.l10n('Active').'</label>
 								<input type="radio" id="" id="inactive-'.$plugin_id.'"name="Plugins['.$plugin_id.'][active]" value="false" '.((!$plugin_config['active'])?'checked="checked"':'').'/>
 								<label for="inactive-'.$plugin_id.'">'.l10n('Inactive').'</label>';
 							}
-						$PAGE_CONTENT[0] .= '</span>
+						$PAGE['content'] .= '</span>
 						
 					</div>';
@@ -244,13 +244,13 @@
 						include('plugins/'.$plugin_id.'/setup.php');
 					}
-				$PAGE_CONTENT[0] .= '</li>';
+				$PAGE['content'] .= '</li>';
 			}
 			
-		$PAGE_CONTENT[0] .= '</ul>
+		$PAGE['content'] .= '</ul>
 	</div>';
 	
 
-	$PAGE_CONTENT[2] .= '<div class="generic link">
-		<input type="submit" value="'.l10n('Valid').'"/>
+	$PAGE['end'] .= '<div class="generic link">
+		<input type="submit" name="submit" value="'.l10n('Valid').'"/>
 		<input type="reset" onclick="location.href=\'index.php\'" value="'.l10n('Back').'"/>
 	</div>
Index: extensions/PHP_Optimisateur/index.php
===================================================================
--- extensions/PHP_Optimisateur/index.php	(revision 9633)
+++ extensions/PHP_Optimisateur/index.php	(revision 10337)
@@ -2,18 +2,26 @@
 /***************************************\
 |			PHP OPTIMISATEUR			|
-|			  Version 1.3.3				|
+|			  Version 1.4				|
 \***************************************/
 
 session_start();
 set_time_limit(7200);
+define('ROOT_DIR', dirname(__FILE__).'\\');
 
-$APPversion = '1.3';
+$APPversion = '1.4';
 $TIME_START = microtime(true);
 $ERRORS = array();
 $CONF = array();
-$PAGE_CONTENT = array(0=>null,1=>null,2=>null);
+$LOG = array();
+$PAGE = array(
+	'section' => 'home',
+	'header' => null,
+	'content' => null,
+	'msgs' => null,
+	'end' => null,
+);
 
 include('include/functions.php');
-$PAGE = (isset($_GET['page'])) ? $_GET['page'] : 'home';
+if (isset($_GET['page'])) $PAGE['section'] = $_GET['page'];
 
 
@@ -21,5 +29,5 @@
 ### CONFIGURATION ###
 if (!file_exists('config.xml')) {
-	$ERRORS['fatal']['ErrorConfigFile'] = true;
+	$ERRORS['fatal'][] = 'ErrorConfigFile';
 } else {
 	$CONF = load_config('config.xml');
@@ -27,45 +35,113 @@
 
 if (!file_exists('include/nconvert.exe')) {
-	$ERRORS['fatal']['ErrorNconvert'] = true;
+	$ERRORS['fatal'][] = 'ErrorNconvert';
+}
+
+$CONF = array_merge($CONF, GetLanguage());
+include('language/'.$CONF['user_lang'].'/common.lang.php');
+
+
+
+### PROCESSUS ###
+switch ($PAGE['section']) {
+	case 'home':
+		if (!isset($ERRORS['fatal'])) {
+			if (!file_exists($CONF['DIRsource'])) {
+				mkdir($CONF['DIRsource']);
+			}
+			if (!file_exists($CONF['DIRsortie'])) {
+				mkdir($CONF['DIRsortie']);
+			}
+			if (is_dir_empty($CONF['DIRsource'])) {
+				$ERRORS['fatal'][] = 'ErrorFolderIn';
+			}
+			if ($CONF['silentORNOT'] == 'block' AND !is_dir_empty($CONF['DIRsortie'])) {
+				$ERRORS['fatal'][] = 'ErrorFolderOut';
+			} else if ($CONF['silentORNOT'] == 'erase' AND !is_dir_empty($CONF['DIRsortie'])) {
+				$ERRORS['notice'][] = 'EraseFolderOut';
+			}
+		}
+		break;
+		
+	case 'setup':
+		if (isset($_POST['submit'])) {
+			include('include/save_config.php');
+		}
+		break;
+	
+	case 'process':
+		include('include/main.php');
+		break;
 }
 
 
 
-### HEADER ###
-$CONF = array_merge($CONF, GetLanguage());
-include('language/'.$CONF['user_lang'].'/'.$CONF['user_lang'].'.php');
-include('include/header.php');
+### AFFICHAGE ###
+switch ($PAGE['section']) {
+	case 'home':
+		include('include/display_config.php');
+		
+		if (isset($ERRORS['fatal'])) {
+			$PAGE['end'] .= '
+			<div class="generic link">
+				<a class="input-submit" href="index.php">'.l10n('Reload').'</a>
+				<a class="input-submit" href="index.php?page=setup">'.l10n('Config').'</a>
+			</div>';
 
+		} else {
+			$PAGE['end'] .= '
+			<div class="generic finish">
+				<span id="ready-text">'.l10n('Ready').'</span>
+				<span id="loader"><img src="template/favicon.png" alt="PHP OPT"/></span>
+			</div>
+			<div class="generic link">
+				<a class="input-submit" href="index.php?page=process" onclick="Load();">'.l10n('Launch').'</a>
+				<a class="input-submit" href="index.php?page=setup">'.l10n('Config').'</a>
+			</div>';
+		}
+		break;
+		
+	case 'setup':
+		if (isset($ERRORS['fatal'])) {
+			$PAGE['end'] .= '
+			<div class="generic link">
+				<a class="input-submit" href="index.php">'.l10n('Back').'</a>
+				<a class="input-submit" href="index.php?page=setup">'.l10n('Reload').'</a>
+			</div>';
 
+		} else {
+			include('include/setup.php');
+		}
+		break;
+	
+	case 'process':
+		### Affichage des fichiers traités et création du log ###
+		$nb_files = count($FilesSource);
+		$time = intval((microtime(true)-$TIME_START));
+		$logfile = print_log($nb_files, $time);
+		
+		$PAGE['content'] .= '
+		<div class="generic files">
+			<h2>'.l10n('Source files').'</h2>
+			<ul>';
+				foreach ($FilesSource as $value) {
+					$PAGE['content'] .= '<li>'.$value.'</li>';
+				}
+			$PAGE['content'] .= '</ul>
+			<i>'.l10n('%d files', $nb_files).'</i><br>
+			<b>Log :</b> <a href="logs/'.$logfile.'">'.$logfile.'</a>
+		</div>';
+		
 
-### PROCESSUS ###
-if ($PAGE == 'home') {
-	if (!isset($ERRORS['fatal'])) {
-		if (!file_exists($CONF['DIRsource'])) {
-			mkdir($CONF['DIRsource']);
-		}
-		if (!file_exists($CONF['DIRsortie'])) {
-			mkdir($CONF['DIRsortie']);
-		}
-		if (is_dir_empty($CONF['DIRsource'])) {
-			$ERRORS['fatal']['ErrorFolderIn'] = true;
-		}
-		if ($CONF['silentORNOT'] == 'block' AND !is_dir_empty($CONF['DIRsortie'])) {
-			$ERRORS['fatal']['ErrorFolderOut'] = true;
-		} else if ($CONF['silentORNOT'] == 'erase' AND !is_dir_empty($CONF['DIRsortie'])) {
-			$ERRORS['notice']['EraseFolderOut'] = true;
-		}
-	}
-	
-} else if ($PAGE == 'setup') {
-	if (isset($_GET['ErrorConfig'])) {
-		$ERRORS['notice']['ErrorConfig'] = true;
-	}
-	if (isset($_POST['DIRsource'])) {
-		include('include/save_config.php');
-	}
-	
-} else if ($PAGE = 'process') {
-	include('include/main.php');
+		unset($FilesSource);
+		unset($FilesSortie);
+		
+		$PAGE['end'] .= '
+		<div class="generic finish">'.l10n('Finish %d seconds', $time).'</div>
+		<div class="generic link">
+			<a class="input-submit" href="index.php">'.l10n('Back').'</a>
+			<a class="input-submit" href="index.php?page=setup">'.l10n('Config').'</a>
+		</div>';
+		break;
 }
 
@@ -73,81 +149,36 @@
 
 ### ERREURS ###
+// erreurs fatales
 if (isset($ERRORS['fatal'])) {
-	$PAGE_CONTENT[1] .= '<div class="generic error">';
-		foreach ($ERRORS['fatal'] as $key => $i) {
-			$PAGE_CONTENT[1] .= '<div>'.l10n('fatal.'.$key).'</div>';
+	$PAGE['msgs'] .= '<div class="generic error">';
+		foreach ($ERRORS['fatal'] as $key) {
+			$PAGE['msgs'] .= '<div>'.l10n('fatal.'.$key).'</div>';
 		}
-	$PAGE_CONTENT[1] .= '</div>';
+	$PAGE['msgs'] .= '</div>';
 }
+// informations
 if (isset($ERRORS['notice'])) {
-	$PAGE_CONTENT[1] .= '<div class="generic notice">';
-		foreach ($ERRORS['notice'] as $key => $i) {
-			$PAGE_CONTENT[1] .= '<div>'.l10n('notice.'.$key).'</div>';
+	$PAGE['msgs'] .= '<div class="generic notice">';
+		foreach ($ERRORS['notice'] as $key) {
+			$PAGE['msgs'] .= '<div>'.l10n('notice.'.$key).'</div>';
 		}
-	$PAGE_CONTENT[1] .= '</div>';
+	$PAGE['msgs'] .= '</div>';
+}
+// erreurs de configuration
+if (isset($ERRORS['conf'])) {
+	$PAGE['msgs'] .= '<div class="generic notice conf">';
+		foreach ($ERRORS['conf'] as $key) {
+			$PAGE['msgs'] .= '<div>'.l10n('notice.'.$key[1].' %s', '<i>'.$key[0].'</i>').'</div>';
+		}
+	$PAGE['msgs'] .= '</div>';
 }
 
 
 
-### AFFICHAGE ###
-if ($PAGE == 'home') {
-	if (isset($ERRORS['fatal'])) {
-		$PAGE_CONTENT[2] .= '
-		<div class="generic link">
-			<a class="input-submit" href="index.php">'.l10n('Back').'</a>
-			<a class="input-submit" href="index.php?page=setup">'.l10n('Config').'</a>
-		</div>';
-
-	} else {
-		include('include/display_config.php');
-		
-		$PAGE_CONTENT[2] .= '
-		<div class="generic finish">
-			<span id="ready-text">'.l10n('Ready').'</span>
-			<span id="loader"><img src="template/favicon.png" alt="PHP OPT"/></span>
-		</div>
-		<div class="generic link">
-			<a class="input-submit" href="index.php?page=process" onclick="Load();">'.l10n('Launch').'</a>
-			<a class="input-submit" href="index.php?page=setup">'.l10n('Config').'</a>
-		</div>';
-	}
-	
-} else if ($PAGE == 'setup') {
-	if (isset($ERRORS['fatal'])) {
-		$PAGE_CONTENT[2] .= '<div class="generic link"><a class="input-submit" href="index.php">'.l10n('Back').'</a></div>';
-
-	} else {
-		include('include/setup.php');
-	}
-	
-} else if ($PAGE = 'process') {
-	### Affichage des fichiers traités ###
-	$PAGE_CONTENT[0] .= '
-	<div class="generic files">
-		<h2>'.l10n('Source files').'</h2>
-		<ul>';
-			foreach ($FilesSource as $value) {
-				$PAGE_CONTENT[0] .= '<li>'.$value.'</li>';
-			}
-		$PAGE_CONTENT[0] .= '</ul>
-		<i>'.l10n('%d files', count($FilesSource)).'</i>
-	</div>';
-
-	unset($FilesSource);
-	unset($FilesSortie);
-	
-	$PAGE_CONTENT[2] .= '
-	<div class="generic finish">'.l10n('Finish %d seconds', intval((microtime(true)-$TIME_START))).'</div>
-	<div class="generic link">
-		<a class="input-submit" href="index.php">'.l10n('Back').'</a>
-		<a class="input-submit" href="index.php?page=setup">'.l10n('Config').'</a>
-	</div>';
-}
-
-
 ### FIN ###
-echo $PAGE_CONTENT[0];
-echo $PAGE_CONTENT[1];
-echo $PAGE_CONTENT[2];
+include('include/header.php');
+echo $PAGE['content'];
+echo $PAGE['msgs'];
+echo $PAGE['end'];
 
 echo '
Index: extensions/PHP_Optimisateur/language/de_DE/common.lang.php
===================================================================
--- extensions/PHP_Optimisateur/language/de_DE/common.lang.php	(revision 10337)
+++ extensions/PHP_Optimisateur/language/de_DE/common.lang.php	(revision 10337)
@@ -0,0 +1,69 @@
+<?php
+$Lang['fatal.ErrorConfigFile'] = "Schwerwiegender Fehler: Konfigurationsdatei fehlt.";
+$Lang['fatal.ErrorFolderIn'] = "Schwerwiegender Fehler: Input-Ordner ist leer.";
+$Lang['fatal.ErrorFolderOut'] = "Schwerwiegender Fehler: Output Ordner ist nicht leer.";
+$Lang['fatal.ErrorNconvert'] = "Schwerwiegender Fehler: Das Programm <i>nconvert.exe</i> wurde nicht gefunden.";
+$Lang['fatal.ErrorConfig'] = "Schwerwiegender Fehler: Konfiguration nicht korrekt.";
+$Lang['notice.EraseFolderOut'] = "Warnung: Der Output Ordner wird komplett gelehrt.";
+$Lang['notice.ErrorConfig'] = "Einige Konfigurationsfehler wurden gefixt , bitte kontrollieren Sie Ihre Einstellungen.";
+$Lang['notice.must_be_integer %s'] = "%s must be an integer.";
+$Lang['notice.must_be_integer_100 %s'] = "%s must be a decimal below 100.";
+$Lang['notice.must_be_decimal %s'] = "%s must be a decimal.";
+
+$Lang['Source files'] = "Bearbeitete Dateien";
+$Lang['%d files'] = "%d Dateien";
+$Lang['Finish %d seconds'] = "Prozess durchgeführt: %d Sekunden.";
+$Lang['Ready'] = "Bereit zum Start.";
+$Lang['Processing'] = "In Verarbeitung";
+$Lang['Launch'] = "Start";
+$Lang['Config'] = "Konfigurieren";
+$Lang['Back'] = "Zurück";
+$Lang['Reload'] = "Reload";
+$Lang['Saved'] = "Configuration saved. <i>Redirection...</i>";
+$Lang['Configuration'] = "Konfiguration";
+$Lang['Folders'] = "Ordner";
+$Lang['FolderIn'] = "Input-Ordner";
+$Lang['FolderOut'] = "Output Ordner";
+$Lang['Options'] = "Optionen";
+$Lang['silentORNOT'] = "Wenn Output Ordner nicht lehr ist";
+$Lang['DIRhighORNOT'] = "HD Ordner erstellen";
+$Lang['DIMhdORNOT'] = " Größe der HD Bilder ändern";
+$Lang['renameORNOT'] = "Dateien und Ordner umbenennen";
+$Lang['indexORNOT'] = "index.php Dateien hinzufügen";
+$Lang['prefixe_mini'] = "Präfix der Miniaturbilder";
+$Lang['Sizes and quality'] = "Größe und Qualität";
+$Lang['DIMhd'] = "Maximal Größe der HD Bilder";
+$Lang['DIMnormal'] = "Maximal Größe der normalen Bilder";
+$Lang['DIMthumbnail'] = "Größe der Miniaturbilder";
+$Lang['Qhd'] = "Qualität der HD Bilder";
+$Lang['Qnormal'] = "Qualität der normalen Bilder";
+$Lang['Qthumbnail'] = "Qualität der Miniaturbilder";
+$Lang['DPI'] = "Auflösung der HD Bilder";
+$Lang['Copyright'] = "Copyright";
+$Lang['Content'] = "Inhalt";
+$Lang['copyONhd'] = "in HD";
+$Lang['copyONnormal'] = "Normal";
+$Lang['copyPOS%s'] = "%s Position";
+$Lang['copyPOSh'] = "Horizontal ";
+$Lang['copyPOSv'] = "Vertikal ";
+$Lang['copySIZE'] = "Größe (Ratio Bild/Text)";
+$Lang['copyCOLOR'] = "Farbe";
+$Lang['copyFONT'] = "Schriftart";
+$Lang['Plugins'] = "Plug-Ins";
+$Lang['yes'] = "Ja";
+$Lang['no'] = "Nein";
+$Lang['top'] = "Oben";
+$Lang['center'] = "Mitte";
+$Lang['bottom'] = "Unten";
+$Lang['left'] = "Links";
+$Lang['right'] = "Rechts";
+$Lang['erase'] = "Löschen";
+$Lang['pass'] = "Fortfahren";
+$Lang['block'] = "Block";
+$Lang['New !'] = "Neu !";
+$Lang['Missing !'] = "Fehlt!";
+$Lang['Reset'] = "Reset";
+$Lang['Valid'] = "Validieren";
+$Lang['Active'] = "Aktiv";
+$Lang['Inactive'] = "Inaktiv";
+?>
